class JSONDOM {
    constructor({ name, element }) {
        this.name = name || 'Element';
        this.element = element || null;
        this.children = [];
        this.props = {};

        return new Proxy(this, {
            get: (target, prop) => {
                if (prop in target) return target[prop];
                if (prop in target.props) return target.props[prop];
                target.props[prop] = null;
                return null;
            },
            set: (target, prop, value) => {
                if (prop in target) {
                    target[prop] = value;
                } else {
                    target.props[prop] = value;
                }
                return true;
            },
            ownKeys: (target) => [...Object.keys(target), ...Object.keys(target.props)],
            getOwnPropertyDescriptor: (target, prop) => {
                if (prop in target) return Reflect.getOwnPropertyDescriptor(target, prop);
                if (prop in target.props) {
                    return { configurable: true, enumerable: true, value: target.props[prop] };
                };
                return undefined;
            }
        });
    }
};

export default JSONDOM;